var Immutable, Page, React, ReactDOM, defaultInfo, jsonPersistent, rawPersistent, recorder, render, schema, updater;

React = require("react");

ReactDOM = require('react-dom');

Immutable = require("immutable");

recorder = require("./recorder");

updater = require("./updater");

schema = require('./schema');

require("origami-ui");

require("../style/main.css");

defaultInfo = {
  initial: schema.store,
  updater: updater,
  inProduction: false
};

rawPersistent = localStorage.getItem("actions-recorder");

if (rawPersistent) {
  try {
    jsonPersistent = JSON.parse(rawPersistent);
    defaultInfo.initial = Immutable.fromJS(jsonPersistent.initial);
    defaultInfo.records = Immutable.fromJS(jsonPersistent.records);
    defaultInfo.pointer = jsonPersistent.pointer;
    defaultInfo.isTravelling = jsonPersistent.isTravelling;
  } catch (_error) {}
}

recorder.setup(defaultInfo);

if (module.hot) {
  module.hot.accept(['./updater', './schema'], function() {
    schema = require('./schema');
    updater = require('./updater');
    return recorder.hotSetup({
      initial: schema.store,
      updater: updater
    });
  });
}

window.onbeforeunload = function() {
  return recorder.request(function(core) {
    jsonPersistent = {
      records: core.get('records').toJS(),
      initial: core.get('initial').toJS(),
      pointer: core.get('pointer'),
      isTravelling: core.get('isTravelling')
    };
    rawPersistent = JSON.stringify(jsonPersistent);
    return localStorage.setItem("actions-recorder", rawPersistent);
  });
};

Page = React.createFactory(require("./app/page"));

render = function(core) {
  return ReactDOM.render(Page({
    core: core
  }), document.querySelector('.app'));
};

recorder.request(render);

recorder.subscribe(render);
