exports.add = function(store, actionData) {
  return store.push(actionData);
};

exports.update = function(store, actionData) {
  var id, text;
  id = actionData.get("id");
  text = actionData.get("text");
  return store.map(function(task) {
    if (task.get("id") === id) {
      return task.set("text", text);
    } else {
      return task;
    }
  });
};

exports.toggle = function(store, id) {
  return store.map(function(task) {
    if (task.get("id") === id) {
      return task.update("done", function(done) {
        return !done;
      });
    } else {
      return task;
    }
  });
};

exports.remove = function(store, id) {
  return store.filterNot(function(task) {
    return task.get("id") === id;
  });
};
